"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.start = void 0;
const string_argv_1 = require("string-argv");
const running_process_1 = require("./running-process");
/** starts a new ObservableProcess with the given options */
function start(command, options = {}) {
    // determine args
    if (!command) {
        throw new Error("start: no command to execute given");
    }
    let argv = [];
    // TODO: instanceOfString
    if (instanceOfString(command)) {
        argv = string_argv_1.default(command);
    }
    else if (instanceOfArray(command)) {
        argv = command;
    }
    else {
        throw new Error("you must provide the command to run as a string or string[]");
    }
    const [runnable, ...params] = argv;
    // start the process
    return new running_process_1.RunningProcess({
        cwd: options.cwd || process.cwd(),
        env: options.env || process.env,
        params,
        runnable,
    });
}
exports.start = start;
function instanceOfString(arg) {
    return typeof arg === "string";
}
function instanceOfArray(arg) {
    return Array.isArray(arg);
}
//# sourceMappingURL=start.js.map